#!/bin/bash
#
# Ex.2020/6/18 Jacky
# 後續須搭配 sql_check2.sh 使用

# 將主機帳號列表輸出至 account_list
ls -l /var/cpanel/userdata/ | awk '{print $9}' | grep -v 'nobody' | grep -v '^$' > account_list

# 確認本機備份每個帳號資料庫備份檔數量與每個帳號資料庫實際數量是否有差異，將有差異的帳號列表輸出至 list1
# 僅抓取60天以內有更新的資料庫備份檔案 (可隨需求更改以下 bak 對應的指令)
echo '' > list1
filename='account_list'
exec < $filename
while read line
do

bak=`ls -l /backup/cpbackup/daily/account/$line/mysql/*.sql | grep -v 'roundcube.sql' | wc -l`
#bak=`find /backup/cpbackup/daily/account/$line/mysql/ -name *.sql -mtime -60 | grep -v 'roundcube.sql' | wc -l`
sql=`ls -ld /var/lib/mysql/$line* | wc -l`

if [ $bak != $sql ]
then
#echo '此帳號需要處理: ' $line '備份檔數量: ' $bak '本機數量: ' $sql
echo $line >> list1
fi

done
sed -i '/^$/d' list1

# 使用 list1 帳號列表，將全部帳號資料庫絕對路徑輸出至 list2
echo '' > list2
filename='list1'
exec < $filename
while read line
do

ls -l /backup/cpbackup/daily/account/$line/mysql/*.sql | grep -v 'roundcube.sql' | awk '{print $9}' >> list2

done
sed -i '/^$/d' list2

# 將 list2 資料庫列表取出資料庫名稱，輸出成 list3
cat list2 | awk -F'/' '{print $8}' | awk -F'.' '{print $1}' > list3

# 參考 list3 資料庫列表，與本機資料庫比對，將找不到目錄的資料庫，輸出成 import_list
echo '' > import_list
filename='list3'
exec < $filename
while read line
do

db="/var/lib/mysql/$line"
if [ ! -e $db ]; then
echo $line >> import_list
fi

done
sed -i '/^$/d' import_list

